"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class ChromosomalRearrangement(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "rearrangements",
        "reportEvents",
        "variantCalls",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_13 import reports as reports_6_5_0

        return {
            "breakPoints": reports_6_5_0.BreakPoint,
            "rearrangements": reports_6_5_0.Rearrangement,
            "reportEvents": reports_6_5_0.ReportEvent,
            "variantAttributes": reports_6_5_0.VariantAttributes,
            "variantCalls": reports_6_5_0.VariantCall,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_13 import reports as reports_6_5_0

        return {
            "org.gel.models.report.avro.BreakPoint": reports_6_5_0.BreakPoint,
            "org.gel.models.report.avro.Rearrangement": reports_6_5_0.Rearrangement,
            "org.gel.models.report.avro.ReportEvent": reports_6_5_0.ReportEvent,
            "org.gel.models.report.avro.VariantAttributes": reports_6_5_0.VariantAttributes,
            "org.gel.models.report.avro.VariantCall": reports_6_5_0.VariantCall,
            "org.gel.models.report.avro.ChromosomalRearrangement": reports_6_5_0.ChromosomalRearrangement,
        }

    __slots__ = [
        "rearrangements",
        "reportEvents",
        "variantCalls",
        "breakPoints",
        "variantAttributes",
    ]

    def __init__(
        self,
        rearrangements,
        reportEvents,
        variantCalls,
        breakPoints=None,
        variantAttributes=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_6_5_0.ChromosomalRearrangement model.

        :param rearrangements:
        :type rearrangements: list[Rearrangement]
        :param reportEvents:
        :type reportEvents: list[ReportEvent]
        :param variantCalls:
            array of genotypes for the samples
        :type variantCalls: list[VariantCall]
        :param breakPoints:
        :type breakPoints: None | list[BreakPoint]
        :param variantAttributes:
        :type variantAttributes: None | VariantAttributes
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "6.5.0"
